"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-20241004054146473
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    set_model_init_error,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.appliance_device_upgrade_policy_relationship import ApplianceDeviceUpgradePolicyRelationship
    from intersight.model.appliance_key_value_pair import ApplianceKeyValuePair
    from intersight.model.appliance_metadata_manifest_version import ApplianceMetadataManifestVersion
    from intersight.model.asset_device_registration_relationship import AssetDeviceRegistrationRelationship
    from intersight.model.onprem_cluster_info import OnpremClusterInfo
    globals()['ApplianceDeviceUpgradePolicyRelationship'] = ApplianceDeviceUpgradePolicyRelationship
    globals()['ApplianceKeyValuePair'] = ApplianceKeyValuePair
    globals()['ApplianceMetadataManifestVersion'] = ApplianceMetadataManifestVersion
    globals()['AssetDeviceRegistrationRelationship'] = AssetDeviceRegistrationRelationship
    globals()['OnpremClusterInfo'] = OnpremClusterInfo


class ApplianceDeviceStateAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'APPLIANCE.DEVICESTATE': "appliance.DeviceState",
        },
        ('object_type',): {
            'APPLIANCE.DEVICESTATE': "appliance.DeviceState",
        },
        ('connection_status',): {
            'EMPTY': "",
            'CONNECTED': "Connected",
            'NOTCONNECTED': "NotConnected",
            'CLAIMINPROGRESS': "ClaimInProgress",
            'UNCLAIMINPROGRESS': "UnclaimInProgress",
            'UNCLAIMED': "Unclaimed",
            'CLAIMED': "Claimed",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'block_reasons': ([str], none_type,),  # noqa: E501
            'blocked_version': (str,),  # noqa: E501
            'capabilities': ([ApplianceKeyValuePair], none_type,),  # noqa: E501
            'certificate': (str,),  # noqa: E501
            'certificate_not_after': (datetime,),  # noqa: E501
            'cluster_info': (OnpremClusterInfo,),  # noqa: E501
            'connection_status': (str,),  # noqa: E501
            'current_fingerprint': (str,),  # noqa: E501
            'current_version': (str,),  # noqa: E501
            'dc_version': (str,),  # noqa: E501
            'desired_version': (str,),  # noqa: E501
            'downloaded_fingerprint': (str,),  # noqa: E501
            'downloaded_metadata_version': ([ApplianceMetadataManifestVersion], none_type,),  # noqa: E501
            'downloaded_version': (str,),  # noqa: E501
            'hostname': (str,),  # noqa: E501
            'pending_fingerprint': (str,),  # noqa: E501
            'pending_version': (str,),  # noqa: E501
            'serial_id': (str,),  # noqa: E501
            'upgrade_blocked': (bool,),  # noqa: E501
            'registered_device': (AssetDeviceRegistrationRelationship,),  # noqa: E501
            'upgrade_policy': (ApplianceDeviceUpgradePolicyRelationship,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'block_reasons': 'BlockReasons',  # noqa: E501
        'blocked_version': 'BlockedVersion',  # noqa: E501
        'capabilities': 'Capabilities',  # noqa: E501
        'certificate': 'Certificate',  # noqa: E501
        'certificate_not_after': 'CertificateNotAfter',  # noqa: E501
        'cluster_info': 'ClusterInfo',  # noqa: E501
        'connection_status': 'ConnectionStatus',  # noqa: E501
        'current_fingerprint': 'CurrentFingerprint',  # noqa: E501
        'current_version': 'CurrentVersion',  # noqa: E501
        'dc_version': 'DcVersion',  # noqa: E501
        'desired_version': 'DesiredVersion',  # noqa: E501
        'downloaded_fingerprint': 'DownloadedFingerprint',  # noqa: E501
        'downloaded_metadata_version': 'DownloadedMetadataVersion',  # noqa: E501
        'downloaded_version': 'DownloadedVersion',  # noqa: E501
        'hostname': 'Hostname',  # noqa: E501
        'pending_fingerprint': 'PendingFingerprint',  # noqa: E501
        'pending_version': 'PendingVersion',  # noqa: E501
        'serial_id': 'SerialId',  # noqa: E501
        'upgrade_blocked': 'UpgradeBlocked',  # noqa: E501
        'registered_device': 'RegisteredDevice',  # noqa: E501
        'upgrade_policy': 'UpgradePolicy',  # noqa: E501
    }

    read_only_vars = {
        'blocked_version',  # noqa: E501
        'certificate',  # noqa: E501
        'certificate_not_after',  # noqa: E501
        'connection_status',  # noqa: E501
        'current_fingerprint',  # noqa: E501
        'current_version',  # noqa: E501
        'dc_version',  # noqa: E501
        'desired_version',  # noqa: E501
        'downloaded_fingerprint',  # noqa: E501
        'downloaded_version',  # noqa: E501
        'hostname',  # noqa: E501
        'pending_fingerprint',  # noqa: E501
        'pending_version',  # noqa: E501
        'serial_id',  # noqa: E501
        'upgrade_blocked',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """ApplianceDeviceStateAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "appliance.DeviceState", must be one of ["appliance.DeviceState", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "appliance.DeviceState", must be one of ["appliance.DeviceState", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            block_reasons ([str], none_type): [optional]  # noqa: E501
            blocked_version (str): Version string of the current software bundle that is blocked for upgrade in the Intersight Appliance. It is used by UI to show banner message for blocked upgrade.. [optional]  # noqa: E501
            capabilities ([ApplianceKeyValuePair], none_type): [optional]  # noqa: E501
            certificate (str): Certificate to be used for verifying software upgrade bundles. Intersight's upgrade service sets the certificate dynamically when the Intersight Appliance queries DeviceState.. [optional]  # noqa: E501
            certificate_not_after (datetime): Expiration date of the software bundle verification certificate.. [optional]  # noqa: E501
            cluster_info (OnpremClusterInfo): [optional]  # noqa: E501
            connection_status (str): Intersight Appliance's connectivity status. ConnectionStatus field is updated infrequently, and value may not be up to date. However, upgrade service will populate this field with actual value when queried. * `` - The target details have been persisted but Intersight has not yet attempted to connect to the target. * `Connected` - Intersight is able to establish a connection to the target and initiate management activities. * `NotConnected` - Intersight is unable to establish a connection to the target. * `ClaimInProgress` - Claim of the target is in progress. A connection to the target has not been fully established. * `UnclaimInProgress` - Unclaim of the target is in progress. Intersight is able to connect to the target and all management operations are supported. * `Unclaimed` - The device was un-claimed from the users account by an Administrator of the device. Also indicates the failure to claim Targets of type HTTP Endpoint in Intersight. * `Claimed` - Target of type HTTP Endpoint is successfully claimed in Intersight. Currently no validation is performed to verify the Target connectivity from Intersight at the time of creation. However invoking API from Intersight Orchestrator fails if this Target is not reachable from Intersight or if Target API credentials are incorrect.. [optional] if omitted the server will use the default value of ""  # noqa: E501
            current_fingerprint (str): Fingerprint of the software bundle that is currently installed in the Intersight Appliance.. [optional]  # noqa: E501
            current_version (str): Version string of the current software bundle that is installed in the Intersight Appliance.. [optional]  # noqa: E501
            dc_version (str): Version string of the Intersight Appliance's device connector. Device connector reports version number during the initial handshake.. [optional]  # noqa: E501
            desired_version (str): The desired software bundle version of the Intersight Appliance.. [optional]  # noqa: E501
            downloaded_fingerprint (str): Fingerprint of the downloaded software bundle.. [optional]  # noqa: E501
            downloaded_metadata_version ([ApplianceMetadataManifestVersion], none_type): [optional]  # noqa: E501
            downloaded_version (str): Intersight appliance software bundle version downloaded on the endpoint. Once Intersight Appliance upgrade service starts processing the version, it is updated as pending version.. [optional]  # noqa: E501
            hostname (str): Hostname of the Intersight Appliance.. [optional]  # noqa: E501
            pending_fingerprint (str): Fingerprint of the pending software bundle.. [optional]  # noqa: E501
            pending_version (str): Version string of the pending software bundle that the Intersight Appliance will install.. [optional]  # noqa: E501
            serial_id (str): SerialId of the Intersight Appliance. SerialId is generated when the Intersight Appliance is setup. SerialId is a unique UUID string, and it will not change for the life time of the Intersight Appliance.. [optional]  # noqa: E501
            upgrade_blocked (bool): Flag to indicate whether upgrade on this Intersight Appliance is blocked.. [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
            upgrade_policy (ApplianceDeviceUpgradePolicyRelationship): [optional]  # noqa: E501
        """

        class_id = "appliance.DeviceState" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "appliance.DeviceState")
        object_type = "appliance.DeviceState" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "appliance.DeviceState")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """ApplianceDeviceStateAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "appliance.DeviceState", must be one of ["appliance.DeviceState", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "appliance.DeviceState", must be one of ["appliance.DeviceState", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            block_reasons ([str], none_type): [optional]  # noqa: E501
            blocked_version (str): Version string of the current software bundle that is blocked for upgrade in the Intersight Appliance. It is used by UI to show banner message for blocked upgrade.. [optional]  # noqa: E501
            capabilities ([ApplianceKeyValuePair], none_type): [optional]  # noqa: E501
            certificate (str): Certificate to be used for verifying software upgrade bundles. Intersight's upgrade service sets the certificate dynamically when the Intersight Appliance queries DeviceState.. [optional]  # noqa: E501
            certificate_not_after (datetime): Expiration date of the software bundle verification certificate.. [optional]  # noqa: E501
            cluster_info (OnpremClusterInfo): [optional]  # noqa: E501
            connection_status (str): Intersight Appliance's connectivity status. ConnectionStatus field is updated infrequently, and value may not be up to date. However, upgrade service will populate this field with actual value when queried. * `` - The target details have been persisted but Intersight has not yet attempted to connect to the target. * `Connected` - Intersight is able to establish a connection to the target and initiate management activities. * `NotConnected` - Intersight is unable to establish a connection to the target. * `ClaimInProgress` - Claim of the target is in progress. A connection to the target has not been fully established. * `UnclaimInProgress` - Unclaim of the target is in progress. Intersight is able to connect to the target and all management operations are supported. * `Unclaimed` - The device was un-claimed from the users account by an Administrator of the device. Also indicates the failure to claim Targets of type HTTP Endpoint in Intersight. * `Claimed` - Target of type HTTP Endpoint is successfully claimed in Intersight. Currently no validation is performed to verify the Target connectivity from Intersight at the time of creation. However invoking API from Intersight Orchestrator fails if this Target is not reachable from Intersight or if Target API credentials are incorrect.. [optional] if omitted the server will use the default value of ""  # noqa: E501
            current_fingerprint (str): Fingerprint of the software bundle that is currently installed in the Intersight Appliance.. [optional]  # noqa: E501
            current_version (str): Version string of the current software bundle that is installed in the Intersight Appliance.. [optional]  # noqa: E501
            dc_version (str): Version string of the Intersight Appliance's device connector. Device connector reports version number during the initial handshake.. [optional]  # noqa: E501
            desired_version (str): The desired software bundle version of the Intersight Appliance.. [optional]  # noqa: E501
            downloaded_fingerprint (str): Fingerprint of the downloaded software bundle.. [optional]  # noqa: E501
            downloaded_metadata_version ([ApplianceMetadataManifestVersion], none_type): [optional]  # noqa: E501
            downloaded_version (str): Intersight appliance software bundle version downloaded on the endpoint. Once Intersight Appliance upgrade service starts processing the version, it is updated as pending version.. [optional]  # noqa: E501
            hostname (str): Hostname of the Intersight Appliance.. [optional]  # noqa: E501
            pending_fingerprint (str): Fingerprint of the pending software bundle.. [optional]  # noqa: E501
            pending_version (str): Version string of the pending software bundle that the Intersight Appliance will install.. [optional]  # noqa: E501
            serial_id (str): SerialId of the Intersight Appliance. SerialId is generated when the Intersight Appliance is setup. SerialId is a unique UUID string, and it will not change for the life time of the Intersight Appliance.. [optional]  # noqa: E501
            upgrade_blocked (bool): Flag to indicate whether upgrade on this Intersight Appliance is blocked.. [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
            upgrade_policy (ApplianceDeviceUpgradePolicyRelationship): [optional]  # noqa: E501
        """

        class_id = "appliance.DeviceState" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "appliance.DeviceState")
        object_type = "appliance.DeviceState" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "appliance.DeviceState")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name in self.read_only_vars:
                set_model_init_error(f"Warning : {var_name} is omitted from request payload as it is a read-only property")
                continue
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
