"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-20241004054146473
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    set_model_init_error,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.asset_sudi_info_all_of import AssetSudiInfoAllOf
    from intersight.model.mo_base_complex_type import MoBaseComplexType
    from intersight.model.x509_certificate import X509Certificate
    globals()['AssetSudiInfoAllOf'] = AssetSudiInfoAllOf
    globals()['MoBaseComplexType'] = MoBaseComplexType
    globals()['X509Certificate'] = X509Certificate


class AssetSudiInfo(ModelComposed):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'ASSET.SUDIINFO': "asset.SudiInfo",
        },
        ('object_type',): {
            'ASSET.SUDIINFO': "asset.SudiInfo",
        },
        ('status',): {
            'DEVICESTATUSUNKNOWN': "DeviceStatusUnknown",
            'VERIFIED': "Verified",
            'ENDTOENDVERIFIED': "EndToEndVerified",
            'CERTIFICATEVALIDATIONFAILED': "CertificateValidationFailed",
            'UNSUPPORTEDSIGNATURESCHEME': "UnsupportedSignatureScheme",
            'SIGNATUREVALIDATIONFAILED': "SignatureValidationFailed",
            'UNSUPPORTEDFIRMWARE': "UnsupportedFirmware",
            'UNSUPPORTEDHARDWARE': "UnsupportedHardware",
            'DEVICEERROR': "DeviceError",
            'DEVICENOTRESPONDING': "DeviceNotResponding",
            'INVALIDSIGNATUREENCODING': "InvalidSignatureEncoding",
            'MISSINGSIGNATURE': "MissingSignature",
            'MISSINGSIGNATURESCHEME': "MissingSignatureScheme",
            'MISSINGCERTIFICATE': "MissingCertificate",
            'INVALIDCERTIFICATEENCODING': "InvalidCertificateEncoding",
            'INVALIDIDENTITY': "InvalidIdentity",
            'SUSPECT': "Suspect",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = True

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'pid': (str,),  # noqa: E501
            'serial_number': (str,),  # noqa: E501
            'signature': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'status_details': (str,),  # noqa: E501
            'sudi_certificate': (X509Certificate,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        val = {
        }
        if not val:
            return None
        return {'class_id': val}

    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'pid': 'Pid',  # noqa: E501
        'serial_number': 'SerialNumber',  # noqa: E501
        'signature': 'Signature',  # noqa: E501
        'status': 'Status',  # noqa: E501
        'status_details': 'StatusDetails',  # noqa: E501
        'sudi_certificate': 'SudiCertificate',  # noqa: E501
    }

    read_only_vars = {
        'pid',  # noqa: E501
        'serial_number',  # noqa: E501
        'signature',  # noqa: E501
        'status',  # noqa: E501
        'status_details',  # noqa: E501
    }

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """AssetSudiInfo - a model defined in OpenAPI

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "asset.SudiInfo", must be one of ["asset.SudiInfo", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "asset.SudiInfo", must be one of ["asset.SudiInfo", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            pid (str): The device model (PID) extracted from the X.509 SUDI leaf certificate.. [optional]  # noqa: E501
            serial_number (str): The device SerialNumber extracted from the X.509 SUDI leaf certificate.. [optional]  # noqa: E501
            signature (str): The base64-encoding of a SUDI signature, signed with the provided Trust Anchor Module (TAM) private key and signatureScheme.. [optional]  # noqa: E501
            status (str): The validation status of the device. * `DeviceStatusUnknown` - SUDI validation is done on the establishment of a connection. Before a device connects or after it disconnects, the SUDI validation status is set to this value. * `Verified` - The SUDI signature and certificate have been validated by the device. The device PID, Serial Number, Status and X.509 certificates were validated by a Trusted Anchor Module. The Intersight services have not cross-validated the SUDI signature. * `EndToEndVerified` - The SUDI signature and certificate have been validated by the device and by the Intersight services. The device PID, Serial Number, Status and X.509 certificates were validated by a Trusted Anchor Module. * `CertificateValidationFailed` - Validation of the certificate signing chain failed. * `UnsupportedSignatureScheme` - The SUDI signature scheme is not supported. * `SignatureValidationFailed` - Validation of the SUDI signature has failed. * `UnsupportedFirmware` - The firmware version of the Cisco IMC that is installed does not contain the SUDI APIs needed to perform validation. * `UnsupportedHardware` - The device is a model that does not contain a Trust Anchor Module (TAM) and thus cannot be validated. * `DeviceError` - The device returned an error when it received a SUDIrequrest request. * `DeviceNotResponding` - A request was sent to the device, but no response was received. * `InvalidSignatureEncoding` - The encoding of the SUDI signature is invalid. * `MissingSignature` - The SUDI signature is missing. * `MissingSignatureScheme` - The SUDI signature scheme is missing. * `MissingCertificate` - The SUDI certificate is missing. * `InvalidCertificateEncoding` - The encoding of the SUDI certificate is invalid. * `InvalidIdentity` - The model or serial number of the device is either missing or does not match the certificate attributes. * `Suspect` - The DC claims the SUDI has been verified, but there is no way to validate the claim.. [optional] if omitted the server will use the default value of "DeviceStatusUnknown"  # noqa: E501
            status_details (str): The detailed validation status of the device, such as an error message explaining why the validation failed.. [optional]  # noqa: E501
            sudi_certificate (X509Certificate): [optional]  # noqa: E501
        """

        class_id = "asset.SudiInfo" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "asset.SudiInfo")
        object_type = "asset.SudiInfo" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "asset.SudiInfo")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        required_args = {
            'class_id': class_id,
            'object_type': object_type,
        }
        kwargs.update(required_args)
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]
        composed_keys = set()
        for instance in self._composed_instances:
            composed_keys.update(set(instance.attribute_map.values()))

        for var_name, var_value in kwargs.items():
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            if var_name in composed_keys:
                continue
            setattr(self, var_name, var_value)

        return self


    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
        '_composed_instances',
        '_var_name_to_model_instances',
        '_additional_properties_model_instances',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """AssetSudiInfo - a model defined in OpenAPI

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "asset.SudiInfo", must be one of ["asset.SudiInfo", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "asset.SudiInfo", must be one of ["asset.SudiInfo", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            pid (str): The device model (PID) extracted from the X.509 SUDI leaf certificate.. [optional]  # noqa: E501
            serial_number (str): The device SerialNumber extracted from the X.509 SUDI leaf certificate.. [optional]  # noqa: E501
            signature (str): The base64-encoding of a SUDI signature, signed with the provided Trust Anchor Module (TAM) private key and signatureScheme.. [optional]  # noqa: E501
            status (str): The validation status of the device. * `DeviceStatusUnknown` - SUDI validation is done on the establishment of a connection. Before a device connects or after it disconnects, the SUDI validation status is set to this value. * `Verified` - The SUDI signature and certificate have been validated by the device. The device PID, Serial Number, Status and X.509 certificates were validated by a Trusted Anchor Module. The Intersight services have not cross-validated the SUDI signature. * `EndToEndVerified` - The SUDI signature and certificate have been validated by the device and by the Intersight services. The device PID, Serial Number, Status and X.509 certificates were validated by a Trusted Anchor Module. * `CertificateValidationFailed` - Validation of the certificate signing chain failed. * `UnsupportedSignatureScheme` - The SUDI signature scheme is not supported. * `SignatureValidationFailed` - Validation of the SUDI signature has failed. * `UnsupportedFirmware` - The firmware version of the Cisco IMC that is installed does not contain the SUDI APIs needed to perform validation. * `UnsupportedHardware` - The device is a model that does not contain a Trust Anchor Module (TAM) and thus cannot be validated. * `DeviceError` - The device returned an error when it received a SUDIrequrest request. * `DeviceNotResponding` - A request was sent to the device, but no response was received. * `InvalidSignatureEncoding` - The encoding of the SUDI signature is invalid. * `MissingSignature` - The SUDI signature is missing. * `MissingSignatureScheme` - The SUDI signature scheme is missing. * `MissingCertificate` - The SUDI certificate is missing. * `InvalidCertificateEncoding` - The encoding of the SUDI certificate is invalid. * `InvalidIdentity` - The model or serial number of the device is either missing or does not match the certificate attributes. * `Suspect` - The DC claims the SUDI has been verified, but there is no way to validate the claim.. [optional] if omitted the server will use the default value of "DeviceStatusUnknown"  # noqa: E501
            status_details (str): The detailed validation status of the device, such as an error message explaining why the validation failed.. [optional]  # noqa: E501
            sudi_certificate (X509Certificate): [optional]  # noqa: E501
        """

        class_id = "asset.SudiInfo" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "asset.SudiInfo")
        object_type = "asset.SudiInfo" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "asset.SudiInfo")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        constant_args = {
            '_check_type': _check_type,
            '_path_to_item': _path_to_item,
            '_spec_property_naming': _spec_property_naming,
            '_configuration': _configuration,
            '_visited_composed_classes': self._visited_composed_classes,
        }
        required_args = {
            'class_id': class_id,
            'object_type': object_type,
        }
        kwargs.update(required_args)
        composed_info = validate_get_composed_info(
            constant_args, kwargs, self)
        self._composed_instances = composed_info[0]
        self._var_name_to_model_instances = composed_info[1]
        self._additional_properties_model_instances = composed_info[2]
        discarded_args = composed_info[3]

        for var_name, var_value in kwargs.items():
            if var_name in self.read_only_vars:
                set_model_init_error(f"Warning : {var_name} is omitted from request payload as it is a read-only property")
                continue
            if var_name in discarded_args and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self._additional_properties_model_instances:
                # discard variable.
                continue
            setattr(self, var_name, var_value)

    @cached_property
    def _composed_schemas():
        # we need this here to make our import statements work
        # we must store _composed_schemas in here so the code is only run
        # when we invoke this method. If we kept this at the class
        # level we would get an error because the class level
        # code would be run when this module is imported, and these composed
        # classes don't exist yet because their module has not finished
        # loading
        lazy_import()
        return {
          'anyOf': [
          ],
          'allOf': [
              AssetSudiInfoAllOf,
              MoBaseComplexType,
          ],
          'oneOf': [
          ],
        }
