"""
    Cisco Intersight

    Cisco Intersight is a management platform delivered as a service with embedded analytics for your Cisco and 3rd party IT infrastructure. This platform offers an intelligent level of management that enables IT organizations to analyze, simplify, and automate their environments in more advanced ways than the prior generations of tools. Cisco Intersight provides an integrated and intuitive management experience for resources in the traditional data center as well as at the edge. With flexible deployment options to address complex security needs, getting started with Intersight is quick and easy. Cisco Intersight has deep integration with Cisco UCS and HyperFlex systems allowing for remote deployment, configuration, and ongoing maintenance. The model-based deployment works for a single system in a remote location or hundreds of systems in a data center and enables rapid, standardized configuration and deployment. It also streamlines maintaining those systems whether you are working with small or very large configurations. The Intersight OpenAPI document defines the complete set of properties that are returned in the HTTP response. From that perspective, a client can expect that no additional properties are returned, unless these properties are explicitly defined in the OpenAPI document. However, when a client uses an older version of the Intersight OpenAPI document, the server may send additional properties because the software is more recent than the client. In that case, the client may receive properties that it does not know about. Some generated SDKs perform a strict validation of the HTTP response body against the OpenAPI document.  # noqa: E501

    The version of the OpenAPI document: 1.0.11-20241004054146473
    Contact: intersight@cisco.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from intersight.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    set_model_init_error,
    OpenApiModel
)
from intersight.exceptions import ApiAttributeError


def lazy_import():
    from intersight.model.asset_device_registration_relationship import AssetDeviceRegistrationRelationship
    from intersight.model.ether_port_channel_relationship import EtherPortChannelRelationship
    from intersight.model.fc_physical_port_relationship import FcPhysicalPortRelationship
    from intersight.model.fc_port_channel_relationship import FcPortChannelRelationship
    from intersight.model.inventory_device_info_relationship import InventoryDeviceInfoRelationship
    from intersight.model.network_element_relationship import NetworkElementRelationship
    from intersight.model.port_group_relationship import PortGroupRelationship
    globals()['AssetDeviceRegistrationRelationship'] = AssetDeviceRegistrationRelationship
    globals()['EtherPortChannelRelationship'] = EtherPortChannelRelationship
    globals()['FcPhysicalPortRelationship'] = FcPhysicalPortRelationship
    globals()['FcPortChannelRelationship'] = FcPortChannelRelationship
    globals()['InventoryDeviceInfoRelationship'] = InventoryDeviceInfoRelationship
    globals()['NetworkElementRelationship'] = NetworkElementRelationship
    globals()['PortGroupRelationship'] = PortGroupRelationship


class EquipmentSwitchCardAllOf(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('class_id',): {
            'EQUIPMENT.SWITCHCARD': "equipment.SwitchCard",
        },
        ('object_type',): {
            'EQUIPMENT.SWITCHCARD': "equipment.SwitchCard",
        },
        ('ethernet_switching_mode',): {
            'END-HOST': "end-host",
            'SWITCH': "switch",
        },
        ('fc_switching_mode',): {
            'END-HOST': "end-host",
            'SWITCH': "switch",
        },
        ('power_state',): {
            'UNKNOWN': "unknown",
            'OFF': "off",
            'ON': "on",
            'DENY': "deny",
            'MULTI-BOOT-FAIL': "multi-boot-fail",
        },
        ('status',): {
            'DOWN': "Down",
            'UP': "Up",
        },
        ('thermal',): {
            'UNKNOWN': "unknown",
            'OK': "ok",
            'UPPER-NON-RECOVERABLE': "upper-non-recoverable",
            'UPPER-CRITICAL': "upper-critical",
            'UPPER-NON-CRITICAL': "upper-non-critical",
            'LOWER-NON-CRITICAL': "lower-non-critical",
            'LOWER-CRITICAL': "lower-critical",
            'LOWER-NON-RECOVERABLE': "lower-non-recoverable",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'class_id': (str,),  # noqa: E501
            'object_type': (str,),  # noqa: E501
            'base_mac': (str,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'end_mac': (str,),  # noqa: E501
            'ethernet_switching_mode': (str,),  # noqa: E501
            'fc_switching_mode': (str,),  # noqa: E501
            'hw_version': (str,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'num_ports': (int,),  # noqa: E501
            'out_of_band_ip_address': (str,),  # noqa: E501
            'out_of_band_ip_gateway': (str,),  # noqa: E501
            'out_of_band_ip_mask': (str,),  # noqa: E501
            'out_of_band_mac': (str,),  # noqa: E501
            'part_number': (str,),  # noqa: E501
            'power_state': (str,),  # noqa: E501
            'slot_id': (int,),  # noqa: E501
            'state': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'switch_id': (str,),  # noqa: E501
            'thermal': (str,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'fc_port_channels': ([FcPortChannelRelationship], none_type,),  # noqa: E501
            'fc_ports': ([FcPhysicalPortRelationship], none_type,),  # noqa: E501
            'inventory_device_info': (InventoryDeviceInfoRelationship,),  # noqa: E501
            'network_element': (NetworkElementRelationship,),  # noqa: E501
            'port_channels': ([EtherPortChannelRelationship], none_type,),  # noqa: E501
            'port_groups': ([PortGroupRelationship], none_type,),  # noqa: E501
            'registered_device': (AssetDeviceRegistrationRelationship,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'class_id': 'ClassId',  # noqa: E501
        'object_type': 'ObjectType',  # noqa: E501
        'base_mac': 'BaseMac',  # noqa: E501
        'description': 'Description',  # noqa: E501
        'end_mac': 'EndMac',  # noqa: E501
        'ethernet_switching_mode': 'EthernetSwitchingMode',  # noqa: E501
        'fc_switching_mode': 'FcSwitchingMode',  # noqa: E501
        'hw_version': 'HwVersion',  # noqa: E501
        'name': 'Name',  # noqa: E501
        'num_ports': 'NumPorts',  # noqa: E501
        'out_of_band_ip_address': 'OutOfBandIpAddress',  # noqa: E501
        'out_of_band_ip_gateway': 'OutOfBandIpGateway',  # noqa: E501
        'out_of_band_ip_mask': 'OutOfBandIpMask',  # noqa: E501
        'out_of_band_mac': 'OutOfBandMac',  # noqa: E501
        'part_number': 'PartNumber',  # noqa: E501
        'power_state': 'PowerState',  # noqa: E501
        'slot_id': 'SlotId',  # noqa: E501
        'state': 'State',  # noqa: E501
        'status': 'Status',  # noqa: E501
        'switch_id': 'SwitchId',  # noqa: E501
        'thermal': 'Thermal',  # noqa: E501
        'type': 'Type',  # noqa: E501
        'fc_port_channels': 'FcPortChannels',  # noqa: E501
        'fc_ports': 'FcPorts',  # noqa: E501
        'inventory_device_info': 'InventoryDeviceInfo',  # noqa: E501
        'network_element': 'NetworkElement',  # noqa: E501
        'port_channels': 'PortChannels',  # noqa: E501
        'port_groups': 'PortGroups',  # noqa: E501
        'registered_device': 'RegisteredDevice',  # noqa: E501
    }

    read_only_vars = {
        'description',  # noqa: E501
        'ethernet_switching_mode',  # noqa: E501
        'fc_switching_mode',  # noqa: E501
        'num_ports',  # noqa: E501
        'out_of_band_ip_address',  # noqa: E501
        'out_of_band_ip_gateway',  # noqa: E501
        'out_of_band_mac',  # noqa: E501
        'slot_id',  # noqa: E501
        'state',  # noqa: E501
        'switch_id',  # noqa: E501
        'port_groups',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """EquipmentSwitchCardAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "equipment.SwitchCard", must be one of ["equipment.SwitchCard", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "equipment.SwitchCard", must be one of ["equipment.SwitchCard", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            base_mac (str): The starting (base) MAC address of the switch hardware like \"d0-e0-42-87-39-00\".. [optional]  # noqa: E501
            description (str): Detailed description of this switch hardware.. [optional]  # noqa: E501
            end_mac (str): The ending MAC address of the switch hardware like \"d0-e0-42-87-39-5f\".. [optional]  # noqa: E501
            ethernet_switching_mode (str): The user configured Ethernet switching mode for this switch (End-Host or Switch). * `end-host` - In end-host mode, the fabric interconnects appear to the upstream devices as end hosts with multiple links.In this mode, the switch does not run Spanning Tree Protocol and avoids loops by following a set of rules for traffic forwarding.In case of ethernet switching mode - Ethernet end-host mode is also known as Ethernet host virtualizer. * `switch` - In switch mode, the switch runs Spanning Tree Protocol to avoid loops, and broadcast and multicast packets are handled in the traditional way.This is the traditional switch mode.. [optional] if omitted the server will use the default value of "end-host"  # noqa: E501
            fc_switching_mode (str): The user configured FC switching mode for this switch (End-Host or Switch). * `end-host` - In end-host mode, the fabric interconnects appear to the upstream devices as end hosts with multiple links.In this mode, the switch does not run Spanning Tree Protocol and avoids loops by following a set of rules for traffic forwarding.In case of ethernet switching mode - Ethernet end-host mode is also known as Ethernet host virtualizer. * `switch` - In switch mode, the switch runs Spanning Tree Protocol to avoid loops, and broadcast and multicast packets are handled in the traditional way.This is the traditional switch mode.. [optional] if omitted the server will use the default value of "end-host"  # noqa: E501
            hw_version (str): The Hardware version of the switch hardware.. [optional]  # noqa: E501
            name (str): The name of the switch card like Line Card-1.. [optional]  # noqa: E501
            num_ports (int): Number of ports present in this switch hardware.. [optional]  # noqa: E501
            out_of_band_ip_address (str): Field specifies this Switch's Out-of-band IP address.. [optional]  # noqa: E501
            out_of_band_ip_gateway (str): Field specifies this Switch's default gateway for the out-of-band management interface.. [optional]  # noqa: E501
            out_of_band_ip_mask (str): Field specifies the Netmask for this Switch's Out-of-band IP address.. [optional]  # noqa: E501
            out_of_band_mac (str): The MAC address of the Switch's out-of-band management interface.. [optional]  # noqa: E501
            part_number (str): The part number of the switch hardware.. [optional]  # noqa: E501
            power_state (str): Power state of the switch hardware. * `unknown` - The power state of the switch hardware is unknown. * `off` - The power state of the switch hardware is off. * `on` - The power state of the switch hardware is on. * `deny` - The power state of the switch hardware is deny. * `multi-boot-fail` - The power state of the switch hardware is multi-boot-fail.. [optional] if omitted the server will use the default value of "unknown"  # noqa: E501
            slot_id (int): Slot identifier of the local Switch slot Interface.. [optional]  # noqa: E501
            state (str): Operational state of the switch hardware.. [optional]  # noqa: E501
            status (str): The connection status of the switch hardware like up/down. * `Down` - Connection status of the switch card is down. * `Up` - Connection status of the switch card is up.. [optional] if omitted the server will use the default value of "Down"  # noqa: E501
            switch_id (str): Switch Identifier that is local to a cluster.. [optional]  # noqa: E501
            thermal (str): The Thermal status of the fabric interconnect. * `unknown` - The default state of the sensor (in case no data is received). * `ok` - State of the sensor indicating the sensor's temperature range is okay. * `upper-non-recoverable` - State of the sensor indicating that the temperature is extremely high above normal range. * `upper-critical` - State of the sensor indicating that the temperature is above normal range. * `upper-non-critical` - State of the sensor indicating that the temperature is a little above the normal range. * `lower-non-critical` - State of the sensor indicating that the temperature is a little below the normal range. * `lower-critical` - State of the sensor indicating that the temperature is below normal range. * `lower-non-recoverable` - State of the sensor indicating that the temperature is extremely below normal range.. [optional] if omitted the server will use the default value of "unknown"  # noqa: E501
            type (str): Type of the switch card based on the capability like 4 Gbps or 2 Gbps type etc.. [optional]  # noqa: E501
            fc_port_channels ([FcPortChannelRelationship], none_type): An array of relationships to fcPortChannel resources.. [optional]  # noqa: E501
            fc_ports ([FcPhysicalPortRelationship], none_type): An array of relationships to fcPhysicalPort resources.. [optional]  # noqa: E501
            inventory_device_info (InventoryDeviceInfoRelationship): [optional]  # noqa: E501
            network_element (NetworkElementRelationship): [optional]  # noqa: E501
            port_channels ([EtherPortChannelRelationship], none_type): An array of relationships to etherPortChannel resources.. [optional]  # noqa: E501
            port_groups ([PortGroupRelationship], none_type): An array of relationships to portGroup resources.. [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
        """

        class_id = "equipment.SwitchCard" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "equipment.SwitchCard")
        object_type = "equipment.SwitchCard" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "equipment.SwitchCard")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """EquipmentSwitchCardAllOf - a model defined in OpenAPI

        Args:

        Keyword Args:
            class_id (str): The fully-qualified name of the instantiated, concrete type. This property is used as a discriminator to identify the type of the payload when marshaling and unmarshaling data.. defaults to "equipment.SwitchCard", must be one of ["equipment.SwitchCard", ]  # noqa: E501
            object_type (str): The fully-qualified name of the instantiated, concrete type. The value should be the same as the 'ClassId' property.. defaults to "equipment.SwitchCard", must be one of ["equipment.SwitchCard", ]  # noqa: E501
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            base_mac (str): The starting (base) MAC address of the switch hardware like \"d0-e0-42-87-39-00\".. [optional]  # noqa: E501
            description (str): Detailed description of this switch hardware.. [optional]  # noqa: E501
            end_mac (str): The ending MAC address of the switch hardware like \"d0-e0-42-87-39-5f\".. [optional]  # noqa: E501
            ethernet_switching_mode (str): The user configured Ethernet switching mode for this switch (End-Host or Switch). * `end-host` - In end-host mode, the fabric interconnects appear to the upstream devices as end hosts with multiple links.In this mode, the switch does not run Spanning Tree Protocol and avoids loops by following a set of rules for traffic forwarding.In case of ethernet switching mode - Ethernet end-host mode is also known as Ethernet host virtualizer. * `switch` - In switch mode, the switch runs Spanning Tree Protocol to avoid loops, and broadcast and multicast packets are handled in the traditional way.This is the traditional switch mode.. [optional] if omitted the server will use the default value of "end-host"  # noqa: E501
            fc_switching_mode (str): The user configured FC switching mode for this switch (End-Host or Switch). * `end-host` - In end-host mode, the fabric interconnects appear to the upstream devices as end hosts with multiple links.In this mode, the switch does not run Spanning Tree Protocol and avoids loops by following a set of rules for traffic forwarding.In case of ethernet switching mode - Ethernet end-host mode is also known as Ethernet host virtualizer. * `switch` - In switch mode, the switch runs Spanning Tree Protocol to avoid loops, and broadcast and multicast packets are handled in the traditional way.This is the traditional switch mode.. [optional] if omitted the server will use the default value of "end-host"  # noqa: E501
            hw_version (str): The Hardware version of the switch hardware.. [optional]  # noqa: E501
            name (str): The name of the switch card like Line Card-1.. [optional]  # noqa: E501
            num_ports (int): Number of ports present in this switch hardware.. [optional]  # noqa: E501
            out_of_band_ip_address (str): Field specifies this Switch's Out-of-band IP address.. [optional]  # noqa: E501
            out_of_band_ip_gateway (str): Field specifies this Switch's default gateway for the out-of-band management interface.. [optional]  # noqa: E501
            out_of_band_ip_mask (str): Field specifies the Netmask for this Switch's Out-of-band IP address.. [optional]  # noqa: E501
            out_of_band_mac (str): The MAC address of the Switch's out-of-band management interface.. [optional]  # noqa: E501
            part_number (str): The part number of the switch hardware.. [optional]  # noqa: E501
            power_state (str): Power state of the switch hardware. * `unknown` - The power state of the switch hardware is unknown. * `off` - The power state of the switch hardware is off. * `on` - The power state of the switch hardware is on. * `deny` - The power state of the switch hardware is deny. * `multi-boot-fail` - The power state of the switch hardware is multi-boot-fail.. [optional] if omitted the server will use the default value of "unknown"  # noqa: E501
            slot_id (int): Slot identifier of the local Switch slot Interface.. [optional]  # noqa: E501
            state (str): Operational state of the switch hardware.. [optional]  # noqa: E501
            status (str): The connection status of the switch hardware like up/down. * `Down` - Connection status of the switch card is down. * `Up` - Connection status of the switch card is up.. [optional] if omitted the server will use the default value of "Down"  # noqa: E501
            switch_id (str): Switch Identifier that is local to a cluster.. [optional]  # noqa: E501
            thermal (str): The Thermal status of the fabric interconnect. * `unknown` - The default state of the sensor (in case no data is received). * `ok` - State of the sensor indicating the sensor's temperature range is okay. * `upper-non-recoverable` - State of the sensor indicating that the temperature is extremely high above normal range. * `upper-critical` - State of the sensor indicating that the temperature is above normal range. * `upper-non-critical` - State of the sensor indicating that the temperature is a little above the normal range. * `lower-non-critical` - State of the sensor indicating that the temperature is a little below the normal range. * `lower-critical` - State of the sensor indicating that the temperature is below normal range. * `lower-non-recoverable` - State of the sensor indicating that the temperature is extremely below normal range.. [optional] if omitted the server will use the default value of "unknown"  # noqa: E501
            type (str): Type of the switch card based on the capability like 4 Gbps or 2 Gbps type etc.. [optional]  # noqa: E501
            fc_port_channels ([FcPortChannelRelationship], none_type): An array of relationships to fcPortChannel resources.. [optional]  # noqa: E501
            fc_ports ([FcPhysicalPortRelationship], none_type): An array of relationships to fcPhysicalPort resources.. [optional]  # noqa: E501
            inventory_device_info (InventoryDeviceInfoRelationship): [optional]  # noqa: E501
            network_element (NetworkElementRelationship): [optional]  # noqa: E501
            port_channels ([EtherPortChannelRelationship], none_type): An array of relationships to etherPortChannel resources.. [optional]  # noqa: E501
            port_groups ([PortGroupRelationship], none_type): An array of relationships to portGroup resources.. [optional]  # noqa: E501
            registered_device (AssetDeviceRegistrationRelationship): [optional]  # noqa: E501
        """

        class_id = "equipment.SwitchCard" if len(kwargs.get('class_id','').strip()) == 0 else kwargs.get('class_id', "equipment.SwitchCard")
        object_type = "equipment.SwitchCard" if len(kwargs.get('object_type','').strip()) == 0 else kwargs.get('object_type', "equipment.SwitchCard")
        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.class_id = class_id
        self.object_type = object_type
        for var_name, var_value in kwargs.items():
            if var_name in self.read_only_vars:
                set_model_init_error(f"Warning : {var_name} is omitted from request payload as it is a read-only property")
                continue
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
